<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (32)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="object-methods-this">Object methods, “this”</h1>
    <p>
      Objects are usually created to represent entities of the real world, like
      users, orders and so on:
    </p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">let</span> user <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-2" title="2">  <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;John&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-3" title="3">  <span class="dt">age</span><span class="op">:</span> <span class="dv">30</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="op">};</span></a></code></pre>
    </div>
    <p>
      And, in the real world, a user can <em>act</em>: select something from the
      shopping cart, login, logout etc.
    </p>
    <p>Actions are represented in JavaScript by functions in properties.</p>
    <h2 id="method-examples">Method examples</h2>
    <p>For a start, let’s teach the <code>user</code> to say hello:</p>
    <p>```js run let user = { name: “John”, age: 30 };</p>
    <p><em>!</em> user.sayHi = function() { alert(“Hello!”); }; <em>/!</em></p>
    <p>user.sayHi(); // Hello! ```</p>
    <p>
      Here we’ve just used a Function Expression to create a function and assign
      it to the property <code>user.sayHi</code> of the object.
    </p>
    <p>
      Then we can call it as <code>user.sayHi()</code>. The user can now speak!
    </p>
    <p>
      A function that is a property of an object is called its <em>method</em>.
    </p>
    <p>
      So, here we’ve got a method <code>sayHi</code> of the object
      <code>user</code>.
    </p>
    <p>
      Of course, we could use a pre-declared function as a method, like this:
    </p>
    <p>```js run let user = { // … };</p>
    <p><em>!</em> // first, declare function sayHi() { alert(“Hello!”); };</p>
    <p>// then add as a method user.sayHi = sayHi; <em>/!</em></p>
    <p>user.sayHi(); // Hello! ```</p>
    <p>
      ```smart header=“Object-oriented programming” When we write our code using
      objects to represent entities, that’s called
      <a href="https://en.wikipedia.org/wiki/Object-oriented_programming"
        >object-oriented programming</a
      >, in short: “OOP”.
    </p>
    <p>
      OOP is a big thing, an interesting science of its own. How to choose the
      right entities? How to organize the interaction between them? That’s
      architecture, and there are great books on that topic, like “Design
      Patterns: Elements of Reusable Object-Oriented Software” by E. Gamma, R.
      Helm, R. Johnson, J. Vissides or “Object-Oriented Analysis and Design with
      Applications” by G. Booch, and more. ```
    </p>
    <h3 id="method-shorthand">Method shorthand</h3>
    <p>There exists a shorter syntax for methods in an object literal:</p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="co">// these objects do the same</span></a>
<a class="sourceLine" id="cb2-2" title="2"></a>
<a class="sourceLine" id="cb2-3" title="3">user <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-4" title="4">  <span class="dt">sayHi</span><span class="op">:</span> <span class="kw">function</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb2-5" title="5">    <span class="at">alert</span>(<span class="st">&quot;Hello&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-6" title="6">  <span class="op">}</span></a>
<a class="sourceLine" id="cb2-7" title="7"><span class="op">};</span></a>
<a class="sourceLine" id="cb2-8" title="8"></a>
<a class="sourceLine" id="cb2-9" title="9"><span class="co">// method shorthand looks better, right?</span></a>
<a class="sourceLine" id="cb2-10" title="10">user <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-11" title="11"><span class="op">*!*</span></a>
<a class="sourceLine" id="cb2-12" title="12">  <span class="at">sayHi</span>() <span class="op">{</span> <span class="co">// same as &quot;sayHi: function(){...}&quot;</span></a>
<a class="sourceLine" id="cb2-13" title="13"><span class="op">*</span><span class="ss">/!</span><span class="sc">*</span></a>
<a class="sourceLine" id="cb2-14" title="14"><span class="ss">    alert</span><span class="sc">(</span><span class="ss">&quot;Hello&quot;</span><span class="sc">)</span><span class="ss">;</span></a>
<a class="sourceLine" id="cb2-15" title="15"><span class="ss">  }</span></a>
<a class="sourceLine" id="cb2-16" title="16"><span class="ss">};</span></a></code></pre>
    </div>
    <p>
      As demonstrated, we can omit <code>"function"</code> and just write
      <code>sayHi()</code>.
    </p>
    <p>
      To tell the truth, the notations are not fully identical. There are subtle
      differences related to object inheritance (to be covered later), but for
      now they do not matter. In almost all cases the shorter syntax is
      preferred.
    </p>
    <h2 id="this-in-methods">“this” in methods</h2>
    <p>
      It’s common that an object method needs to access the information stored
      in the object to do its job.
    </p>
    <p>
      For instance, the code inside <code>user.sayHi()</code> may need the name
      of the <code>user</code>.
    </p>
    <p>
      <strong
        >To access the object, a method can use the
        <code>this</code> keyword.</strong
      >
    </p>
    <p>
      The value of <code>this</code> is the object “before dot”, the one used to
      call the method.
    </p>
    <p>For instance:</p>
    <p>```js run let user = { name: “John”, age: 30,</p>
    <p>
      sayHi() { <em>!</em> // “this” is the “current object” alert(this.name);
      <em>/!</em> }
    </p>
    <p>};</p>
    <p>user.sayHi(); // John ```</p>
    <p>
      Here during the execution of <code>user.sayHi()</code>, the value of
      <code>this</code> will be <code>user</code>.
    </p>
    <p>
      Technically, it’s also possible to access the object without
      <code>this</code>, by referencing it via the outer variable:
    </p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">let</span> user <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb3-2" title="2">  <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;John&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb3-3" title="3">  <span class="dt">age</span><span class="op">:</span> <span class="dv">30</span><span class="op">,</span></a>
<a class="sourceLine" id="cb3-4" title="4"></a>
<a class="sourceLine" id="cb3-5" title="5">  <span class="at">sayHi</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb3-6" title="6"><span class="op">*!*</span></a>
<a class="sourceLine" id="cb3-7" title="7">    <span class="at">alert</span>(<span class="va">user</span>.<span class="at">name</span>)<span class="op">;</span> <span class="co">// &quot;user&quot; instead of &quot;this&quot;</span></a>
<a class="sourceLine" id="cb3-8" title="8"><span class="op">*</span><span class="ss">/!</span><span class="sc">*</span></a>
<a class="sourceLine" id="cb3-9" title="9"><span class="ss">  }</span></a>
<a class="sourceLine" id="cb3-10" title="10"></a>
<a class="sourceLine" id="cb3-11" title="11"><span class="ss">};</span></a></code></pre>
    </div>
    <p>
      …But such code is unreliable. If we decide to copy <code>user</code> to
      another variable, e.g. <code>admin = user</code> and overwrite
      <code>user</code> with something else, then it will access the wrong
      object.
    </p>
    <p>That’s demonstrated below:</p>
    <p>```js run let user = { name: “John”, age: 30,</p>
    <p>
      sayHi() { <em>!</em> alert( user.name ); // leads to an error
      <em>/!</em> }
    </p>
    <p>};</p>
    <p>let admin = user; user = null; // overwrite to make things obvious</p>
    <p>
      <em>!</em> admin.sayHi(); // TypeError: Cannot read property ‘name’ of
      null <em>/!</em> ```
    </p>
    <p>
      If we used <code>this.name</code> instead of <code>user.name</code> inside
      the <code>alert</code>, then the code would work.
    </p>
    <h2 id="this-is-not-bound">“this” is not bound</h2>
    <p>
      In JavaScript, keyword <code>this</code> behaves unlike most other
      programming languages. It can be used in any function, even if it’s not a
      method of an object.
    </p>
    <p>There’s no syntax error in the following example:</p>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="kw">function</span> <span class="at">sayHi</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb4-2" title="2">  <span class="at">alert</span>( <span class="op">*!*</span><span class="kw">this</span><span class="op">*</span><span class="ss">/!</span><span class="sc">*</span><span class="ss">.name </span><span class="sc">)</span><span class="ss">;</span></a>
<a class="sourceLine" id="cb4-3" title="3"><span class="ss">}</span></a></code></pre>
    </div>
    <p>
      The value of <code>this</code> is evaluated during the run-time, depending
      on the context.
    </p>
    <p>
      For instance, here the same function is assigned to two different objects
      and has different “this” in the calls:
    </p>
    <p>```js run let user = { name: “John” }; let admin = { name: “Admin” };</p>
    <p>function sayHi() { alert( this.name ); }</p>
    <p>
      <em>!</em> // use the same function in two objects user.f = sayHi; admin.f
      = sayHi; <em>/!</em>
    </p>
    <p>
      // these calls have different this // “this” inside the function is the
      object “before the dot” user.f(); // John (this == user) admin.f(); //
      Admin (this == admin)
    </p>
    <p>
      admin<a href="">‘f’</a>; // Admin (dot or square brackets access the
      method – doesn’t matter) ```
    </p>
    <p>
      The rule is simple: if <code>obj.f()</code> is called, then
      <code>this</code> is <code>obj</code> during the call of <code>f</code>.
      So it’s either <code>user</code> or <code>admin</code> in the example
      above.
    </p>
    <p>
      ```<code>smart header="Calling without an object:</code>this ==
      undefined`" We can even call the function without an object at all:
    </p>
    <p>```js run function sayHi() { alert(this); }</p>
    <p>sayHi(); // undefined</p>
    <pre><code>
In this case `this` is `undefined` in strict mode. If we try to access `this.name`, there will be an error.

In non-strict mode the value of `this` in such case will be the _global object_ (`window` in a browser, we&#39;ll get to it later in the chapter [](info:global-object)). This is a historical behavior that `&quot;use strict&quot;` fixes.

Usually such call is a programming error. If there&#39;s `this` inside a function, it expects to be called in an object context.
</code></pre>
    <p>
      ``<code>smart header="The consequences of unbound</code>this<code
        >" If you come from another programming language, then you are probably
        used to the idea of a "bound</code
      >this<code>", where methods defined in an object always have</code>this`
      referencing that object.
    </p>
    <p>
      In JavaScript <code>this</code> is “free”, its value is evaluated at
      call-time and does not depend on where the method was declared, but rather
      on what object is “before the dot”.
    </p>
    <p>
      The concept of run-time evaluated <code>this</code> has both pluses and
      minuses. On the one hand, a function can be reused for different objects.
      On the other hand, the greater flexibility creates more possibilities for
      mistakes.
    </p>
    <p>
      Here our position is not to judge whether this language design decision is
      good or bad. We’ll understand how to work with it, how to get benefits and
      avoid problems. ```
    </p>
    <h2 id="arrow-functions-have-no-this">Arrow functions have no “this”</h2>
    <p>
      Arrow functions are special: they don’t have their “own”
      <code>this</code>. If we reference <code>this</code> from such a function,
      it’s taken from the outer “normal” function.
    </p>
    <p>
      For instance, here <code>arrow()</code> uses <code>this</code> from the
      outer <code>user.sayHi()</code> method:
    </p>
    <p>
      ```js run let user = { firstName: “Ilya”, sayHi() { let arrow = () =&gt;
      alert(this.firstName); arrow(); } };
    </p>
    <p>user.sayHi(); // Ilya</p>
    <pre><code>
That&#39;s a special feature of arrow functions, it&#39;s useful when we actually do not want to have a separate `this`, but rather to take it from the outer context. Later in the chapter &lt;info:arrow-functions&gt; we&#39;ll go more deeply into arrow functions.


## Summary

- Functions that are stored in object properties are called &quot;methods&quot;.
- Methods allow objects to &quot;act&quot; like `object.doSomething()`.
- Methods can reference the object as `this`.

The value of `this` is defined at run-time.
- When a function is declared, it may use `this`, but that `this` has no value until the function is called.
- A function can be copied between objects.
- When a function is called in the &quot;method&quot; syntax: `object.method()`, the value of `this` during the call is `object`.

Please note that arrow functions are special: they have no `this`. When `this` is accessed inside an arrow function, it is taken from outside.</code></pre>
  </body>
</html>
